// Fill out your copyright notice in the Description page of Project Settings.

#include "MyObject.h"

// Sets default values
AMyObject::AMyObject()
{
 	// Set this actor to call Tick() every frame.  You can turn this off to improve performance if you don't need it.
	PrimaryActorTick.bCanEverTick = true;
	
	auto mcomp = CreateDefaultSubobject<UStaticMeshComponent>(TEXT("StaticMeshComponent"));
	RootComponent = MeshComponent = mcomp;

	auto mesh = ConstructorHelpers::FObjectFinder<UStaticMesh>(TEXT("StaticMesh'/Engine/BasicShapes/Cube.Cube'")).Object;
	mcomp->SetStaticMesh(mesh);
	mcomp->SetWorldScale3D({ 2.0f, 4.0f, 2.0f });
	mcomp->SetMassOverrideInKg();

	mcomp->SetSimulatePhysics(true); // aby se dala pridavat sila
	mcomp->SetEnableGravity(false); // letani ve 3d (jinak pouze rotace)

	mcomp->SetLinearDamping(5.0); // aby se casem zpomalila
	mcomp->SetAngularDamping(5.0); // aby se casem prestala tocit
	
	// define path to material material
	Material = ConstructorHelpers::FObjectFinder<UMaterial>(TEXT("Material'/Engine/EngineDebugMaterials/LightingModels/M_TextureDefinedSpecularReflecti.M_TextureDefinedSpecularReflecti'")).Object;

}

// Called when the game starts or when spawned
void AMyObject::BeginPlay()
{
	Super::BeginPlay();
	// set material to the mesh
	MeshComponent->SetMaterial(0, Material);
}

// Called every frame
void AMyObject::Tick(float DeltaTime)
{
	Super::Tick(DeltaTime);
}

void AMyObject::ApplyLeftForce(float value)
{
	FVector forceLocation = { -100.0, -100.0, 0.0 };

	ApplyForce(value, forceLocation);
}

void AMyObject::ApplyRightForce(float value)
{
	FVector forceLocation = { -100.0, 100.0, 0.0 };

	ApplyForce(value, forceLocation);
}

void AMyObject::ApplyForce(float value, FVector location) {

	FTransform arrowTransform;

	auto arrowLocation = GetActorRotation().Quaternion().RotateVector(location);
	arrowTransform.SetLocation(GetActorLocation() + arrowLocation);
	arrowTransform.SetRotation(GetActorRotation().Quaternion());

	GetWorld()->SpawnActor(ArrowClass, &arrowTransform);

	FVector force = { value, 0.0, 0.0 };
	MeshComponent->AddForceAtLocationLocal(force, location);
}
