// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "GameFramework/Actor.h"
#include "Components/StaticMeshComponent.h"
#include "MyObject.generated.h"

UCLASS()
class DYNAMICSTEMPLATE_API AMyObject : public AActor
{
	GENERATED_BODY()
	
public:	
	// Sets default values for this actor's properties
	AMyObject();

protected:
	// Called when the game starts or when spawned
	virtual void BeginPlay() override;

public:	
	// Called every frame
	virtual void Tick(float DeltaTime) override;
	
	UFUNCTION(BlueprintCallable)
		void ApplyLeftForce(float value);

	UFUNCTION(BlueprintCallable)
		void ApplyRightForce(float value);

	UPROPERTY(EditAnywhere, Category = "Defaults")
		TSubclassOf<AActor> ArrowClass;		

private:
	UStaticMeshComponent* MeshComponent;

	void ApplyForce(float value, FVector location);

	UMaterial* Material;
};
